
Base Distribution - Work Package # 45004

Status: Accepted Priority: Must have
Author: Sebastian Kurfuerst Category: Documentation
Created: 2013-01-31 Assigned To: Karsten Dambekalns
Updated: 2013-05-16 Due date: 2013-05-31
Subject: Write TYPO3 Neos Integrator Guide
Description

Write TYPO3 Neos Integrator Guide
    -  Target Audience: developers and integrators who want to use Neos
    -  Responsible: Karsten Dambekalns <karsten (at) typo3 (dot) org>
    -  Implemented by: Karsten Dambekalns, Sebastian Kurfürst <sebastian (at) typo3 (dot) org>
    -  Amount: 10 work days
    -  Version: must have for 1.0
    -  Planned Implementation Timeframe: week 12 to 15, 2013

Motivation
Anyone who is about to build a website using TYPO3 Neos needs to be able to have the needed knowledge available in a nice to read
documentation. The same is true for developers about to write plugins for Neos or work on the system itself.

In the past the lack of documentation for TYPO3 has always been mentioned (justified or not) as an impediment for adoption. And
even those who recognized the existing documentation complain about the learning curve.

Goal
To make it easy for integrators and developers to get into TYPO3 Neos it is thus needed to have documentation available that is 
concise, easy to understand and available at an early point in the product lifecycle.

What has been started at https://review.typo3.org/17510 will be used as base for this.

Deliverables
    -  Integrator topics to be covered [MUST]
        -  ✔ Installation / Getting started
        -  ✔ TYPO3CR: structure, nodes and content types
        -  ✔ How a page is rendered
        -  ✔ Using custom templates for the site and custom elements
        -  ✔ TypoScript introduction
        -  Using TypoScript to tweak rendering (cookbook style)
        -  TypoScript objects and Patterns (TODO Sebastian)
        -  ✔ TypoScript inside (concepts and motivation on TypoScript)
        -  ✔ Creating custom content types
        -  Configuring Neos UI elements for types
        -  Creating a plugin for Neos (TODO: should be Developer Guide, not Integrator Guide)
        -  Localisation using a multi-tree approach
        -  Site deployment (using Surf)
    -  Neos developer topics to be covered [MUST]
        -  Coding guidelines
        -  Working on the UI
        -  FE system architecture
        -  (TODO Sebastian) Diagram: How the content module works (and a little text)
        -  Creating custom "backend" modules
    -  ✔ have the guide rendered on docs.typo3.org [MUST]
    -  ✔ have the guide advertised/linked on neos.typo3.org [MUST]
    -  ✔ written in english [MUST]
    -  proofread by a native speaker

Related issues:
related to Base Distribution - Story # 41586: write Neos Integrator Guide Accepted
related to Base Distribution - Story # 44969: Document Two-Tree Localization ... New
related to Base Distribution - Story # 44970: Define Neos 1.0 API New 2013-01-30
related to Base Distribution - Task # 45032: Oudated install documentation Resolved 2013-01-31
related to Base Distribution - Task # 45033: Should we really suggest '--dev'... Resolved 2013-01-31
related to Base Distribution - Task # 45034: Mention setfilepermissions in in... Resolved 2013-01-31
related to Base Distribution - Task # 45035: 'First visit' guide New 2013-01-31
related to Base Distribution - Task # 46722: Check/update "Your first plugin" Resolved 2013-03-27

Associated revisions
Revision 32e11039 - 2013-03-28 12:13 - Sebastian Kurfuerst

[FEATURE] Add Neos Integrator Guide

Start of the integrator guide, neither complete nor the last change
touching this.

Change-Id: I4dbb214d985f3dfcdd4a48bb4f417bb0bb0b40a2
Related: #41586
Related: #45004

Revision a4ac8e81 - 2013-03-28 12:13 - Karsten Dambekalns

[TASK] Reorganize documentation

This takes the existing documentation and reorganizes it in a more
structured way.

Some markup adjustments are done (mostly to keep nesting levels
correct) and a few tiny content tweaks sneak in almost unnoticed.

Change-Id: Ieadd388557090163bbef3e2baa9be8bd4a2387f7
Related: #41586
Related: #45004

Revision b316a8fa - 2013-05-07 18:12 - Karsten Dambekalns

[TASK] Improve FlowQuery operations documentation

This change improves the class and method docblocks of the FlowQuery
operations implemented in the Neos package. They are used to generate a
reference for the documentation in the future.

Change-Id: Ia115311dd04b9ccc92da62bf6730137503dddac7
Related: #45004

Revision 2ce36c07 - 2013-05-07 18:12 - Karsten Dambekalns

[TASK] Adjust Integrators Guide to "node  types"
The documentation now uses node type instead of the old term content
type. Also it has been checked, corrected and tweaked besides that.

Change-Id: Ic3af0710ce1307b0b12404c0c1c71185a6c0e742
Related: #45004
Related: #41586

Revision cc046656 - 2013-05-07 18:25 - Karsten Dambekalns

[TASK] Improve TS Processor documentation

This change improves the class and method docblocks of the TypoScript
Processors implemented in this package. They are used to generate a
reference for the Neos documentation in the future.

Change-Id: I389fda8c84bf78abeed1df6dbc0702bd77e5004f
Related: #45004

Revision 48568d7c - 2013-05-08 09:39 - Karsten Dambekalns

[TASK] Update TypoScript, FlowQuery, Eel documentation

This change updates the TypoScript part of the Integrators Guide to make
it more consistent and up-to-date with recent changes. It also fills a
number of holes in it: TS namespaces, processors, Eel, FlowQuery, Fizzle
are now documented.

A FlowQuery operations reference is added, generated using TYPO3.DocTools
with a new parser that has been added.

Change-Id: Ice3b94c505a590baa69c5e445f6fb2e6280464ce
Related: #45004

Revision b5b83b59 - 2013-05-08 09:39 - Karsten Dambekalns

[TASK] Add processor reference to TypoScript documentation

A processor reference is added, generated using TYPO3.DocTools with a
new parser that has been added.

Change-Id: Iee57f2c85c0218b4a600f4811fe74c9f6c34bd90
Related: #45004

Revision 274bcfb6 - 2013-05-08 09:49 - Karsten Dambekalns

[TASK] Add reference labels to files

Change-Id: Ic8292181347df787afb70321b189729df3f5fd7a
Related: #45004
Revision 939a292a - 2013-05-08 09:52 - Karsten Dambekalns

[TASK] Various fixes to documentation

This change tweaks language in a few places, adds some headlines as
placeholders for missing content and moves parts around. Some rST markup
tweaks are done as well.

Change-Id: I6e7801f428d175f17822bb37f25511fc76be1e0f
Related: #45004

Revision 4eb55a6d - 2013-05-15 15:52 - Karsten Dambekalns

[TASK] Update and amend section on content element creation

The section on creating custom content elements is updated to the
current Neos behavior and amended with new content.

Change-Id: I8e5ea1aa0fdb80057b075d29ff84259dd23f4b60
Related: #45004

Revision 9fb0485b - 2013-05-15 15:55 - Karsten Dambekalns

[TASK] Move around sections and add content

Removes the (empty) user guide, moves some sections around and adds
new (placeholder) content to some parts.

Change-Id: Id049475efc590da40d0f80a1147253dd81929da8
Related: #45004

Revision 52319e14 - 2013-05-15 15:55 - Karsten Dambekalns

[TASK] Add command reference content

A command reference for Neos generated with the DocTools.

Change-Id: Icdf6873a4975a7282f81b846829a1bd8935d2238
Related: #45004

Revision e00d2b8e - 2013-05-15 15:59 - Karsten Dambekalns

[TASK] Improve FlowQuery operations documentation

This change improves the class and method docblocks of the FlowQuery
operations implemented in the Eel package. They are used to generate a
reference for the Neos documentation in the future.
In additions some more fixes are done to docblocks.

Change-Id: I6dfb359199bf6372c72131cb0fefc17940ee3555
Related: #45004

Revision e6901f3b - 2013-05-16 01:34 - Karsten Dambekalns

[TASK] Tweak section nesting in Eel chapter

Adjusts the nesting in the Eel section so that FlowQuery and Fizzle are
nested inside the Eel chapter.

Change-Id: I4108d75d696e383b5c65374610116c7eb7dc213c
Related: #45004

Revision 9b25b0c5 - 2013-07-06 12:14 - Sebastian Kurfuerst

[WIP][FEATURE] add TypoScript reference

Related: #45004
Change-Id: I261423505394b9ffe9734f567806a797016eb9e5
Reviewed-on: https://review.typo3.org/20999
Reviewed-by: Sebastian Kurfuerst
Tested-by: Sebastian Kurfuerst

History
#1 - 2013-01-31 11:02 - Sebastian Kurfuerst
- Subject changed from Write TYPO3 Neos Integrator Guide to [WIP] Write TYPO3 Neos Integrator Guide
- Assigned To set to Karsten Dambekalns

#2 - 2013-01-31 17:13 - Karsten Dambekalns
- Subject changed from [WIP] Write TYPO3 Neos Integrator Guide to Write TYPO3 Neos Integrator Guide
- Category set to Documentation

#3 - 2013-02-03 20:40 - Sebastian Kurfuerst

If possible, please also fix #45032, #45033, #45034; absolute bonus: #45035

#4 - 2013-02-16 14:59 - Sebastian Kurfuerst
- Status changed from New to Accepted

#5 - 2013-02-16 15:18 - Sebastian Kurfuerst
- File typo3neos-distribution-base-45004.pdf added
- Due date set to 2013-04-16
- Start date changed from 2013-01-31 to 2013-03-12
- Estimated time set to 60.00

Has been discussed with Jan-Hendrik from the EAB on 12.02.2013; and has been accepted on 15.02.2013 by the EAB.

2015-08-04 5/7

https://review.typo3.org/20999


(The attached PDF is a snapshot of this work package at the time of acceptance.)

So, Karsten (and myself), you can schedule this work package in your day-to-day calendar and implement it then -- can't wait to see it in Neos 1.0 :-)

Another side-note: Please do not forget to add comments to this work package and update "% done" while you are working on this package.

Greets, Sebastian

#6 - 2013-03-27 22:30 - Karsten Dambekalns

Awesome, I just noticed that adding subtasks makes it impossible to set the estimated time on the parent task. Sigh.

#7 - 2013-03-28 12:26 - Karsten Dambekalns
- Estimated time set to 60.00

#8 - 2013-03-28 12:28 - Karsten Dambekalns

Karsten Dambekalns wrote:

Awesome, I just noticed that adding subtasks makes it impossible to set the estimated time on the parent task. Sigh.

I undid that and moved the logged time from the subtasks to this one. Awesome. :)

#9 - 2013-03-28 12:28 - Karsten Dambekalns
- % Done changed from 0 to 10

#10 - 2013-04-02 10:59 - Aske Ertmann

Would it make sense to set the due date to the end of week 15?

#11 - 2013-04-02 13:22 - Bastian Waidelich
- Due date set to 2013-04-20

Just set the due date in order to make it visible in the work package listing at http://neos.typo3.org/work-packages.html

#12 - 2013-05-04 00:16 - Karsten Dambekalns
- Due date changed from 2013-04-20 to 2013-05-17

Set the due date (aka target date) into the future - after our Neos sprint this should be done, I hope.

#13 - 2013-05-06 23:31 - Karsten Dambekalns
- % Done changed from 10 to 20

#14 - 2013-05-13 08:31 - Karsten Dambekalns
- % Done changed from 20 to 30

#15 - 2013-05-16 09:37 - Sebastian Kurfuerst
- % Done changed from 30 to 70

#16 - 2013-05-16 10:08 - Sebastian Kurfuerst
- Due date changed from 2013-05-17 to 2013-05-31
- % Done changed from 70 to 60

Files
typo3neos-distribution-base-45004.pdf 4.4 kB 2013-02-16 Sebastian Kurfuerst
